Removable Storage

Removable Storage makes it easy for you to track your removable storage media (tapes and optical discs) and to manage the libraries, such as changers and jukeboxes, that contain them.

  • Before you begin using Removable Storage, see the Checklist: Configure Removable Storage.
  • For tips about using Removable Storage, see Best Practices.
  • For step-by-step help with specific tasks, see How to...
  • For background information about Removable Storage and how it works, see Concepts.
  • For problem-solving guidelines, see Troubleshooting.


Checklist: configure Removable Storage

Step | Reference
Verify that you have a supported library. | See the Microsoft Windows Hardware Compatibility List at the Microsoft Web site. (http://www.microsoft.com/)
Install and test the library. | Follow the manufacturer's recommendations.
Create new media pools to support applications, as needed. | To create a new media pool.
Move sufficient media to a free media pool. | To move a tape or disc to another media pool.
Set user or group permissions for Removable Storage as needed. | To change user permissions for Removable Storage.


Best practices

The following list represents some best practices for Removable Storage. You should implement this list whenever possible.

  • Verify your library hardware is supported first before using Removable Storage.

    Before adding a new library to a Removable Storage system, see the Microsoft Windows Hardware Compatibility List at the Microsoft Web site for a comprehensive list of the libraries supported by Windows operating systems. (http://www.microsoft.com/)

  • Use only libraries that support drive-element address reporting.

    If you use libraries that support drive-element address reporting, Removable Storage can automatically map each drive in a library to a particular media changer. In addition, you should connect all library drives on the same SCSI bus as the associated media changer. For information on whether your library supports drive-element address reporting, consult the library manufacturer.

  • Insert media into a robotic library before use.

    Before you create a new media pool, insert media into each robotic library you want Removable Storage to control. If a library is empty, Removable Storage cannot detect the media type.

  • Keep your media count under 1,000 per system installation.

    For performance reasons, do not manage more than 1,000 tapes or discs in a single Removable Storage system.


How to...

This section provides step-by-step instructions for performing administrative tasks using the Removable Storage snap-in in an MMC console.

  • View or set Removable Storage properties
  • Manage libraries
  • Manage media pools
  • Manage tapes and discs
  • Manage operator requests and queued work
  • Manage security for Removable Storage


View or set Removable Storage properties

To view or set Removable Storage properties

  2. In the console tree, double-click the applicable item.
  3. Right-click that item, and then click Properties.
  4. In the object Properties dialog box, review the settings and make any changes.

Notes

  • To view or set properties for specific media pools, library drives, media, or other items, click the applicable folder in the console tree, right-click the specific item in the details pane, and then click Properties.

Related Topics


Manage libraries

  • Enable or disable a library
  • Enable or disable a drive
  • Change the library media type
  • Inventory a library
  • Set the default library inventory
  • Open a library door
  • Set the library door and port time-out
  • Clean a stand-alone drive
  • Clean a robotic library


Enable or disable a library

To enable or disable a library

  2. In the console tree, double-click Physical Locations.
  3. Right-click the library you want to enable or disable, and then click Properties.

    The library Properties dialog box appears.

  4. On the General tab, verify that the Enable library check box is selected.

    Or, to disable the library, clear the Enable library check box.

Notes

  • Disabling a library makes it unavailable for use.


Enable or disable a drive

To enable or disable a drive

  2. In the console tree, click Drives.

    Where?

    • Removable Storage (computer name)
    • Physical locations
    • applicable library
    • Drives
  3. In the details pane, right-click the applicable drive, and then click Properties.
  4. On the General tab, verify that the Enable drive check box is selected.

    Or, to disable the drive, clear the Enable drive check box.

Notes

  • Disabling a drive makes it unavailable for use.
  • This procedure applies only to robotic libraries. Since stand-alone drive libraries consist of a single drive, you enable or disable the entire library for such cases. For information on how to enable or disable a library, see Related Topics.


Change the library media type

To change the library media type

  2. In the console tree, double-click Physical Locations.
  3. Right-click the library you want to change, and then click Properties.
  4. In the library Properties dialog box, click the Media tab, and then click Change.
  5. In the Change Media Types dialog box, do the following:
    • To add a new media type, in Available types, click the entry you want to add, and then click Add.
    • To remove an existing media type, in Selected types, click the entry you want to remove, and then click Remove.
    • Repeat these steps as necessary.

Note


Inventory a library

To inventory a library

  2. In the console tree, double-click Physical Locations.
  3. Right-click the library you want to inventory, and then click Inventory.

Notes

  • This procedure applies only to robotic libraries.
  • An inventory is automatically performed each time a library door has been accessed.
  • The inventory is performed according to the default inventory method: either Fast, Full, or None. For information on how to change the default inventory method, see Related Topics.


Set the default library inventory

To set the default library inventory

  2. In the console tree, double-click Physical Locations.
  3. Right-click the library you want to set an inventory method for, and then click Properties.
  4. On the General tab, in Inventory Method, click the method you want to use: None, Fast, or Full.

Notes

  • A fast inventory only checks for storage slots that have changed status between being occupied and unoccupied. A full inventory with bar-coded media will read bar-code information. Otherwise, the tape or disc is mounted and the on-media identifier is read.
  • The selected inventory method is automatically performed each time a library door has been accessed.
  • A full inventory is always performed when a mount operation fails, regardless of inventory method selected. To disable this feature, clear the Perform full inventory on mount failure check box.
  • This procedure applies only to robotic libraries.


Open a library door

To open a library door

  2. In the console tree, double-click Physical Locations.
  3. Right-click the applicable library, and then click Door Access.
  4. When prompted, open the door.

Notes

  • You can use the library door to insert or remove media. If the library has an inject/eject port, you can use that to prevent a re-inventory of the media. Make sure you use the correct slots in the library.
  • If you exchange media in a library that are not bar-coded, you must perform a full inventory afterward. The media exchange is not detected during a fast inventory and a media ID mismatch will occur the next time the media in the applicable slot is mounted.
  • This procedure applies only to robotic libraries.


Set the library door and port time-out

To set the library door and port time-out

  2. In the console tree, double-click Physical Locations.
  3. Right-click the applicable library, and then click Properties.
  4. In the library Properties dialog box, click the Components tab.
  5. Under Doors, in Time-out, enter a new value (if necessary) for the door time-out interval (in minutes).
  6. Under Ports, in Time-out, enter a new value (if necessary) for the inject/eject port time-out interval (in minutes).

Notes

  • This procedure applies only to robotic libraries.


Clean a stand-alone drive

To clean a stand-alone drive

  2. In the console tree, click Drives.

    Where?

    • Removable Storage (computer name)
    • Physical locations
    • applicable library
    • Drives
  3. In the results pane, right-click the drive, and then click Mark as Clean.

Notes

  • To clean a stand-alone drive, you manually insert a cleaning cartridge into the stand-alone drive. This procedure is performed only to notify Removable Storage that a stand-alone drive has been manually cleaned so that a record can be kept in the Removable Storage database.
  • This procedure applies only to cleaning the drive in a stand-alone drive library. For information on how to clean drives in a robotic library, see Related Topics.


Clean a robotic library

To clean a robotic library

  2. In the console tree, right-click the library you want to clean.

    Where?

    • Removable Storage (computer name)
    • Physical locations
    • applicable library
  3. Click Cleaner Management.
  4. Follow the instructions in the Cleaner Management wizard.

Notes

  • To complete this procedure, you must insert a cleaner cartridge into the library when prompted. Do not insert a cleaning cartridge using the same method used for inserting regular tapes (such as through the insert/eject port). Follow the instructions in the Cleaner Management wizard.


Manage media pools

  • Create a new media pool
  • Delete an application media pool
  • Automatically draw media from a free media pool
  • Automatically return media to a free media pool
  • Set the allocation limit for a media pool


Create a new media pool

To create a new media pool

  2. In the console tree, right-click Media Pools, and then click Create Media Pool.

    Or, to create a new media pool within another media pool, right-click the applicable media pool and then click Create Media Pool.

  3. On the General tab, in Name, type a name for the new media pool; then, in Description, type a relevant description.
  4. Under Media Information, click Contains media of type, and select the appropriate media type from the list.
  5. Under Allocation/Deallocation policy, do one or more of the following:
    • To automatically draw unused media from a free media pool when needed, select the Draw media from Free media pool check box.
    • To automatically return media to a free media pool when no longer needed, select the Return media to Free media pool check box.
    • To set an allocation limit for media in this media pool, select the Limit reallocations check box, and then change the default value as necessary.

Notes

  • You must have administrative permissions to perform this procedure.
  • You can create media pools within application media pools only. You cannot create new media pools within free, unrecognized, or import media pools.


Delete an application media pool

To delete an application media pool

  2. In the console tree, double-click Media Pools.
  3. Right-click the application media pool you want to delete, and then click Delete.

Notes

  • You cannot delete free, import, or unrecognized media pools.


Automatically draw media from a free media pool

To automatically draw media from a free media pool

  2. In the console tree, double-click Media Pools.
  3. Right-click the applicable media pool, and then click Properties.
  4. On the General tab, select the Draw media from Free media pool check box.

Notes

  • If you do not select the Draw media from Free media pool check box, you must manually move tapes or discs from a free media pool whenever this media pool needs additional media. For information on how to manually move media to a free media pool, see Related Topics.


Automatically return media to a free media pool

To automatically return media to a free media pool

  2. In the console tree, double-click Media Pools.
  3. Right-click the applicable media pool, and then click Properties.
  4. On the General tab, select the Return media to Free media pool check box.

Notes

  • If you do not select the Return media to Free media pool check box, you must manually move tapes or discs in this application media pool to a free media pool when no longer needed. After you do this, another application can use those tapes or discs. For information on how to manually move media to a free media pool, see Related Topics.


Set the allocation limit for a media pool

To set the allocation limit for a media pool

  2. In the console tree, double-click Media Pools.
  3. Right-click the applicable media pool, and then click Properties.
  4. Under Media information, click Contains media of type.
  5. Under Allocation/Deallocation policy, select the Limit reallocations check box, and then change the default value as necessary.

Note


Manage tapes and discs

  • Move a tape or disc to another media pool
  • Enable or disable a tape or disc
  • Insert a tape or disc into a robotic library
  • Eject a tape or disc from a stand-alone drive
  • Eject a tape or disc from a robotic library
  • Mount a tape or disc
  • Dismount a tape or disc from a stand-alone drive
  • Dismount a tape or disc from a robotic library


Move media to another media pool

To move media to another media pool

  2. In the console tree, click Media.

    Where?

    • Removable Storage (computer name)
    • Physical locations
    • applicable library
    • Media
  3. In the details pane, drag the applicable tape or disc from the details pane over to the applicable media pool in the console tree.

Notes

  • When moving media to a free media pool, make sure the data on the tape or disc you are moving is no longer needed. Data will be automatically deleted when the tape or disc is moved to a free media pool. To manually delete data before moving media to a free media pool, right-click the tape or disc and then click Prepare.
  • You cannot move read-only media, such as compact discs, to a free media pool.


Enable or disable a tape or disc

To enable or disable a tape or disc

  2. In the console tree, click Media.

    Where?

    • Removable Storage (computer name)
    • Physical locations
    • applicable library
    • Media
  3. In the details pane, right-click the tape or disc, and then click Properties.
  4. On the Media tab, verify that the Enable media check box is selected.

    Or, to disable the tape or disc, clear the Enable media check box.

Notes

  • Disabling the tape or disc makes it unavailable for use.


Insert a tape or disc into a robotic library

To insert a tape or disc into a robotic library

  2. In the console tree, double-click Physical Locations.
  3. Right-click the applicable library, and then click Inject.
  4. Follow the instructions in the Media Inject wizard.

Notes

  • Insert the tape or disc using the inject/eject port if the library has one. Otherwise, use the library door.
  • Use this procedure only with a robotic library. For a stand-alone drive library, you must manually insert the tape or disc.


Eject a tape or disc from a stand-alone drive

To eject a tape or disc from a stand-alone drive

  2. In the console tree, double-click Physical Locations.
  3. Right-click the applicable library, and then click Eject.

Notes

  • Use this procedure only with a stand-alone drive library. For information on how to eject a tape or disc from a robotic library, see Related Topics.


Eject a tape or disc from a robotic library

To eject a tape or disc from a robotic library

  2. In the console tree, click Media.

    Where?

    • Removable Storage (computer name)
    • Physical locations
    • applicable library
    • Media
  3. In the details pane, right-click the applicable tape or disc, and then click Eject.
  4. Follow the instructions in the Media Eject wizard.

Notes

  • Eject the tape or disc using the inject/eject port if the library has one. Otherwise, use the library door.


Mount a tape or disc

To mount a tape or disc

  2. In the console tree, click Media.

    Where?

    • Removable Storage (computer name)
    • Physical locations
    • applicable library
    • Media
  3. In the details pane, right-click the applicable tape or disc, and then click Mount.

Note


Dismount a tape or disc from a stand-alone drive

To dismount a tape or disc from a stand-alone drive

  2. In the console tree, click Media.

    Where?

    • Removable Storage (computer name)
    • Physical locations
    • applicable library
    • Media
  3. In the results pane, right-click the tape or disc you want to dismount, and then click Dismount.

Notes

  • Use this procedure only to dismount a tape or disc from a stand-alone drive library. For information on how to dismount a tape or disc from a robotic library, see Related Topics.


Dismount a tape or disc from a robotic library

To dismount a tape or disc from a robotic library

  2. In the console tree, click Drives.

    Where?

    • Removable Storage (computer name)
    • Physical locations
    • applicable library
    • Drives
  3. In the results pane, right-click the drive from which you want to dismount the tape or disc, and then click Dismount.

Notes


Manage operator requests and queued work

  • Respond to an operator request
  • Change how operator requests are displayed
  • Delete operator requests
  • Cancel pending operations in the work queue
  • Change the mount order in the work queue


Respond to an operator request

To respond to an operator request

  2. In the console tree, click Operator Requests.
  3. In the details pane, right-click the applicable request, and then do one of the following:
    • To complete the request, click Complete, and then perform the action when prompted.
    • To cancel the request, click Refuse.

Notes

  • Removable Storage stores operator requests for approximately one hour after they have been completed or cancelled.


Change how operator requests are displayed

To change how operator requests are displayed

  2. In the console tree, right-click Removable Storage and then click Properties.
  3. On the General tab, under Options, do the following:
    • To display operator requests in a pop-up window, verify that the Send Operator Requests to Messenger Service check box is selected; otherwise, clear the check box.
    • To display an icon on the Windows taskbar when there are operator requests waiting to be serviced, verify that the Tray Icon for pending Operator Requests check box is selected; otherwise, clear the check box.

Note


Delete operator requests

To delete operator requests

  2. In the console tree, right-click Operator Requests, and then click Properties.
  3. To have all requests automatically deleted, in the Operator Requests Properties dialog box, verify that the Automatically delete completed requests check box is selected.
  4. To automatically delete failed requests also, verify that the Delete failed requests check box is selected.

    Or, to save failed requests, click Keep failed requests.

  5. In Delete after, change the time interval as necessary for automatically deleting requests.
  6. To restore default settings, click Default.
  7. To delete all requests now, click Delete All Now.

Notes

  • Restoring the default settings will automatically delete all requests, including failed requests, every hour.
  • To delete an individual operator request, right-click the applicable request in the details pane, and then click Delete.
  • This procedure also applies for deleting items from the work queue. Right-click Work Queue in the console tree instead.


Cancel pending operations in the work queue

To cancel pending operations in the work queue

  2. In the console tree, click Work Queue.
  3. In the details pane, right-click the applicable item in the work queue, and then click Cancel Request.

Notes

  • You can also delete an item from the work queue by right-clicking the applicable item, and then clicking Delete.
  • You cannot delete work items that are in progress, except for door opening requests.


Change the mount order in the work queue

To change the mount order in the work queue

  2. In the console tree, click Work Queue.
  3. In the details pane, right-click the applicable mount operation, and then click Re-order Mounts.
  4. In the Change Mount Order dialog box, do one of the following:
    • To make the selected mount operation the next to be completed, click Move to the front of the queue.
    • To make the selected mount operation the last to be completed, click Move to the end of the queue.
    • To move the selected mount operation to a specific position in the work queue, click Make it number, and then click the up or down arrow to move the item ahead or behind in the queue.

Note


Manage security for Removable Storage

  • Change user permissions for Removable Storage
  • Add a user for access to Removable Storage


Change user permissions for Removable Storage

To change user permissions for Removable Storage

  2. In the console tree, right-click the specific item you want to change user permissions for, and then click Properties.
  3. In the Properties dialog box, click the Security tab.
  4. Click the name of the user or group whose permissions you want to change, and then do one of the following:
    • To change specific permissions, select or clear the Allow and Deny check boxes for each of the three levels of permissions: Use, Modify, and Control, as applicable.
    • To deny all permissions, click Remove.

Notes

  • You must have administrative permissions to perform this procedure.
  • You can also apply user permissions to Removable Storage as a whole.


Add users for access to Removable Storage

To add users for access to Removable Storage

  2. In the console tree, right-click the specific item you want to add user access to, and then click Properties.
  3. On the Security tab, click Add.
  4. In the Select Users, Computers, or Groups dialog box, in Name, click the applicable users or groups, click Add, and then click OK.
  5. Click the name of the user or group that you just added, and then do one of the following:
    • To change specific permissions, select or clear the Allow and Deny check boxes for each of the three levels of permissions: Use, Modify, and Control, as applicable.
    • To deny all permissions, click Remove.

Notes

  • You must have administrative permissions to perform this procedure.
  • You can also add user access to Removable Storage as a whole.
  • To add a user or group from a different domain, in Look in, scroll through the list, and then click a domain to search before clicking Add in Step 4.


Concepts

These topics provide background information about Removable Storage.

  • Removable Storage overview
  • Understanding Removable Storage
  • Using Removable Storage
  • Resources


Removable Storage overview

Removable Storage makes it easy for you to track your removable storage media (tapes and optical discs) and to manage the hardware libraries, such as changers and jukeboxes, that contain them. Removable Storage labels, catalogs, and tracks media; controls library drives, slots, and doors; and provides drive-cleaning operations.

Removable Storage works in concert with your data-management programs, such as Backup. You use data-management programs to manage the actual data stored on the media. Removable Storage makes it possible for multiple programs to share the same storage media resources, which can reduce your costs.

Removable Storage organizes all the media in your libraries into different media pools. Removable Storage also moves media between media pools in order to provide the amount of data storage your applications require.

Removable Storage does not provide volume management, such as for media siding or striping. Also, Removable Storage does not provide file management, such as for data backup or disk-extender operations. These services are done by data-management applications such as Backup or Remote Storage. (Remote Storage is not available on computers running Windows 2000 Professional.)

You must run all your data-management programs on the same computer that connects to your library. Removable Storage does not support multiple data-management programs running on different computers that are connected to the same library.


Understanding Removable Storage

This section describes how Removable Storage works.

For information about specific topics, see:

  • Removable Storage components
  • Libraries
  • Media pools
  • Media identification
  • Media states


Removable Storage components

Removable Storage is comprised of an administrative interface implemented as a Microsoft Management Console (MMC) snap-in, a Windows 2000 service with an API, and a database. The Removable Storage service provides media services to data-management programs through the API. The following figure illustrates the relationship between Removable Storage, data management programs, libraries, and Windows 2000.

Figure showing Removable Storage and your computer

You can use the Removable Storage snap-in to perform the following tasks:

  • Create media pools and set media pool properties.
  • Insert and eject media in a robotic library.
  • Mount and dismount media.
  • View the operational state of media and libraries.
  • Perform library inventories.
  • Set security permissions for users.

Note

  • You do not use the Removable Storage API or database to perform administrative tasks. For more information on the Removable Storage API and database, including how to program to them, see the Windows 2000 Resource Kit.


Libraries

In its simplest form, a library is comprised of data storage media and the device used to read from and write to the media. The group of libraries and associated media that are managed by a Removable Storage installation is called a Removable Storage system. There are two major types of libraries:

  • Robotic libraries are automated units that hold multiple tapes or discs, and some have multiple drives. These libraries are sometimes called changers or jukeboxes, and commonly use robotic subsystems, or drive bays, to move media stored in the library's storage slots. The drive bay locates the desired tape or disc, mounts it into an available drive, and then returns it to its assigned storage slot after a task is completed. Robotic libraries can also consist of other hardware components that are managed by Removable Storage, such as doors, inject/eject ports, cleaner cartridges, and bar-code readers.
  • Stand-alone drive libraries, or stand-alone drives, are single-drive, nonautomated units, such as tape or CD-ROM drives, that hold a single tape or disc. With these, you manually insert a tape or disc into the unit.

Not only can Removable Storage manage multiple libraries, but it can also track offline media that are not currently contained in a library. These media might be anywhere: on a shelf or in a drawer. Every tape or disc that is offline belongs to a library.


Media pools

A media pool is a collection of tapes or discs to which the same management properties apply. All media in a Removable Storage system belong to a media pool, and each media pool holds only one type of media. Data management programs use media pools to gain access to specific tapes or discs within a library.

Using media pools, you can define properties that apply to a set of media. This is useful because Removable Storage allows multiple programs to share the same media within a single library. A library can include media from different media pools, each with different properties. A single media pool can span multiple libraries. You can also create hierarchies of media pools, or media pools that contain other media pools. For example, you can create a media pool for each specific media type required by a program, and then create another media pool that contains this collection of media pools. Media pools can contain either media or other media pools, but not both.

A Removable Storage system provides two classes of media pools: system and application.

System media pools include free media pools, unrecognized media pools, and import media pools. Removable Storage creates one free, one unrecognized, and one import media pool for each media type in your Removable Storage system. The system media pools are used to hold media that are not currently being used by an application.

Application media pools are created by data management programs such as Backup and Remote Storage (the latter for computers running Windows 2000 Server).

The different media pools are defined as follows:

  • Unrecognized media pools contain blank (new) media and media that Removable Storage does not recognize. You should immediately move a new tape or disc from an unrecognized media pool to a free media pool so that the tape or disc can be used by applications, or remove it from the library.

    Unrecognized media are automatically deleted from the Removable Storage database when they are ejected from a library.

  • Import media pools contain media that Removable Storage recognizes in the database but that have not been used before in a particular Removable Storage system. For example, media in an import media pool could be media from one office location that are introduced into a Removable Storage system at another office location.

    You can move media from import media pools to free media pools or application media pools for reuse at the new location.

  • Free media pools contain media that are not currently in use by applications and do not contain useful data. Media in free media pools are available for use by applications.

    Application media pools can be configured to automatically draw media from free media pools when there are not sufficient media available in a particular application media pool. If this configuration is not implemented, you must manually move media from a free media pool when needed.

  • Application media pools, created by data management applications (and by you), determine what media can be accessed by which applications.

    Media in an application media pool are controlled by that application or by an administrator. An application can use more than one media pool, and more than one application can share a single media pool. For example, Backup might use one media pool for full-backup and another media pool for incremental backup, each containing a different media type.

    There can be any number of application media pools in a Removable Storage system. Media that are currently reserved for use by an application, called allocated media, cannot be moved between media pools. Allocation controls how the media are used by applications.

The following illustration shows how media can move from one media pool to another.

Figure showing how Removable Storage moves media between media pools


Media identification

Removable Storage uses two identification methods to track media and perform inventories: on-media identifiers and bar codes.

On-media identifiers

On-media identifiers are electronically recorded on media the first time a tape or disc is inserted into a library. The next time the medium is inserted into the library, Removable Storage uses the on-media identifier to recognize and track the tape or disc.

An on-media identifier has two parts: a label type and a label ID. The label type identifies the specific format used to record information on the tape or disc, such as Microsoft Tape Format (MTF). The label ID is a unique identifier for the tape or disc in the Removable Storage system. If Removable Storage does not recognize the label type, it puts the medium in an unrecognized media pool. If Removable Storage recognizes the label type but does not recognize the label ID, it puts the media in an import media pool. If Removable Storage recognizes the label type and the label ID, it updates the Removable Storage database to reflect that the medium is online and available for use.

Note

  • Removable Storage does not record on-media identifiers for read-only or write-once optical media, such as CD-ROM, DVD-ROM, CD-R, DVD-R, or WORM discs. Instead, Removable Storage uses the volume and serial number information that is already associated with the disc.

Bar codes

If your library supports bar codes, Removable Storage can use them to identify media. Media with bar codes also have on-media identifiers, and Removable Storage can use either one. Using bar codes to track media is generally much faster because each tape or disc does not have to be mounted to read the on-media identifier.


Media states

The media state identifies the operational status of each tape or disc in a Removable Storage system and therefore determines what operations are permitted. When media are inserted into a library, Removable Storage uses the on-media identifier or bar code to determine its state.

There are two sets of media states that govern media movement and usage by Removable Storage: physical states and side states.

Physical states

The physical states identify operations performed that involve media location or movement. There are five possible physical states:

Physical state | Description
Idle | Tape or disc is currently in a storage slot in a robotic library or is shelved offline.
In-use | Tape or disc is in the process of being moved.
Loaded | Tape or disc is mounted in a drive and data is available to be read or written.
Mounted | Tape or disc is mounted in a drive but data is not yet available to be read or written.
Unloaded | Tape or disc has been dismounted and is ready to be removed from a drive.

Side states

A tape or disc side is where actual information is stored. Side states identify operations performed that involve media usage rather than location or movement. There are nine possible side states:

Side state | Description
Allocated | Side is reserved for use by an application. The side is not available to any other application.
Available | Side is currently available for use by an application.
Completed | Side is in use but cannot be used for write operations. The side is full.
Decommissioned | Side is no longer available for use, as it has reached its allocation maximum.
Imported | Side's label type is recognized but its label ID is not recognized by Removable Storage.
Incompatible | The media type of the side is not compatible with the library. The tape or disc should be removed from the library.
Reserved | Side is unavailable for allocation except by a single application. This applies only to two-sided media where one side has already been allocated.
Unprepared | Side has been placed in a free media pool but does not yet have a free media label. This is a temporary state.
Unrecognized | Side's label type and label ID are not recognized by Removable Storage.

There is a relationship between side states and media pools: Import media pools can only hold media sides in the imported state. Unrecognized media pools can only hold media sides that are in the unrecognized state. Free media pools can only hold media sides that are in the available (and transitional unprepared) state.


Using Removable Storage

This section covers information on using Removable Storage.

For information about specific topics, see:

  • Managing libraries
  • Managing media pools
  • Managing tapes and discs
  • Managing operator requests and queued work
  • Managing security for Removable Storage
  • Using the command line for Removable Storage


Managing libraries

Removable Storage attempts to automatically configure all libraries when you first start Removable Storage and when you add or remove a library from a computer that is running Removable Storage. Removable Storage can always automatically configure stand-alone drives.

You can use the automatic configuration feature of Removable Storage for robotic libraries only if you connect all drives on the same SCSI bus as the associated media changer. Also, you must use robotic libraries that support drive-element address reporting. For information on whether your library supports this feature, consult the library manufacturer.

Note

  • Because not all library configurations support the automatic configuration feature, Removable Storage provides a method for manually configuring libraries. However, do not use this method unless it is absolutely necessary because manually configured libraries do not recognize system configuration changes. They also involve registry changes. For information on how to configure your libraries manually, see the Windows 2000 Resource Kit.

Removable Storage provides comprehensive control and management of libraries. You can enable or disable entire libraries or only specific drives within a library. You can change the media type for a library. You can also open the door on a robotic library and set various time-out values.

For information on how to perform a specific task, click:

  • To enable or disable a library
  • To enable or disable a drive
  • To change the library media type
  • To open a library door
  • To set the library door and port time-out

Inventorying libraries

You can create an inventory of all media in a library. Removable Storage supports two inventory methods:

  • Fast inventory. Removable Storage can do this two ways. If your library has a bar-code reader, Removable Storage creates an inventory of the bar codes. If your library does not have a bar-code reader, Removable Storage checks the storage slots that have changed status between being occupied and unoccupied.
  • Full inventory. Removable Storage mounts each tape or disc in your library and reads the on-media identifier.

For information on how to perform an inventory task, click:

  • To inventory a library
  • To set the default library inventory

Cleaning libraries

Removable Storage can manage the cleaning of an entire robotic library or the drive for a stand-alone drive. Each tape-based robotic library can contain one cleaner cartridge. You can use Removable Storage to clean a drive, assign or release a cleaner slot, and insert or eject a cleaner cartridge. Removable Storage maintains a usage count for each cleaner cartridge. When a cleaner reaches its maximum usage count, Removable Storage generates an operator request. If you eject a cleaner cartridge before it has reached its maximum usage count, Removable Storage deletes the usage count information.

For information on how to perform a specific task, click:

  • To clean a stand-alone drive
  • To clean a robotic library


Managing media pools

After configuring your libraries, you can configure your media pools. Before creating a new media pool, you should answer the following questions:

  • What media types are available in your Removable Storage system?
  • Should media be automatically drawn from a free media pool when there are not sufficient media in an application media pool? (It is recommended that you implement this configuration.)
  • Should media be automatically returned to a free media pool when they are no longer needed by an application?

For information on how to perform a specific task, click:

  • To create a new media pool
  • To delete an application media pool
  • To automatically draw media from a free media pool
  • To automatically return media to a free media pool
  • To set the allocation limit for a media pool

Note

  • You cannot delete system media pools.


Managing tapes and discs

After you create and configure your media pools, you can move media to a specific media pool. It is important that you have a sufficient amount of media in a free media pool so that applications can use media in this pool when needed. For information on how to move media to a free media pool, see To move media to another media pool.

Next, you can use a data management application such as Backup to allocate media to the application media pool created for (or by) that application. Allocating media to an application media pool reserves all media in that media pool for exclusive use by that application. See the documentation for your particular data management application for information on how to reserve media for that application.

Removable Storage provides comprehensive control of tapes or discs in your library. You can enable or disable specific media in your library, insert and eject media, and mount and dismount media.

A tape or disc can be inserted in or ejected from a robotic library using either a library door or an inject/eject port. A library door allows unrestricted access to the media inside. You can add or remove media directly from a storage slot using a door access. An inject/eject port allows controlled access to the media inside. You insert a tape or disc in the port and then the library uses the drive bay to move the media to a storage slot.

A tape or disc can be mounted in or dismounted from a particular drive in a library. You can use the same media many times before dismounting them. You can also mount and dismount the same media many times before deallocating them.

For information on how to perform a specific task, click:

  • To enable or disable a tape or disc
  • To insert a tape or disc into a robotic library
  • To eject a tape or disc from a stand-alone drive
  • To eject a tape or disc from a robotic library
  • To mount a tape or disc
  • To dismount a tape or disc from a stand-alone drive
  • To dismount a tape or disc from a robotic library

Notes

  • Removable Storage requires compact discs to be formatted with the CDFS file system, and rewritable optical media (such as MO discs) to be formatted with either the FAT, FAT32, or NTFS file system.
  • Windows 2000 does not directly support the use of media that can be written to only once, such as WORM, CD-R, and DVD-R discs. If you plan to use these, you must acquire other software that supports these technologies.


Managing operator requests and queued work

The work queue lists all library requests, or work items, whether initiated by an application or by Removable Storage. A request to mount a tape in a library, for example, results in a mount work item listed in the work queue.

The following table describes the states that a work item can have:

Work state | Description
Completed | The work item has been completed successfully.
Failed | Removable Storage was unable to complete the work item.
In Process | Removable Storage is actively operating on the work item.
Queued | The time between when the request is issued and when Removable Storage starts examining the request.
Waiting | One or more resources needed to satisfy the request are currently in use.

An operator request is a message that asks you to perform a specific task. Operator requests can be issued by Removable Storage or by a program that is aware of Removable Storage, such as Backup. Removable Storage can generate an operator request when any of the following occur:

  • An application initiates a mount request for a tape or disc that is offline.
  • There are no available media online. That is, a program requires media, and none exist in the appropriate application media pool or in a free media pool.
  • A library has failed and requires servicing.
  • A drive needs cleaning and no usable cleaner cartridges are available in the library.

You can respond to operator requests by either completing or refusing the operator request. When you refuse an operator request, Removable Storage notifies the application that generated the request. By default, Removable Storage stores an operator request in the work queue for one hour after you respond to the request. For information on how to respond to an operator request, see To respond to an operator request.

The following table describes the states that an operator request can have:

Operator request state | Description
Completed | You have indicated, or Removable Storage has detected, that the operator request was completed.
Refused | You have indicated that the operator request will not be performed.
Submitted | Removable Storage or an application has submitted an operator request for action.

You can change how operator requests are displayed on your computer, delete operator requests, cancel any pending operation listed in the work queue, and change the order of mount requests in the work queue. For information on how to perform a specific task, click:

  • To change how operator requests are displayed
  • To delete operator requests
  • To cancel pending operations in the work queue
  • To change the mount order in the work queue


Managing security for Removable Storage

Removable Storage provides user-level security for media pools and libraries. Media pool security controls user access to media. Library security controls user access to library drives, slots, and inject/eject ports.

User permissions determine which users or groups of users can access media pools and libraries. Before assigning permissions for a particular media pool or library, it is a good idea to use Active Directory Users and Computers to create a user group containing the accounts of users who need access to a media pool or library.

For information on how to perform a specific task, click:

  • To change user permissions for Removable Storage
  • To add users for access to Removable Storage


Using the command line for Removable Storage

You can use the command-line utility for Removable Storage to manage media resources and to write batch scripts for applications that do not currently support the Removable Storage API (are not aware of Removable Storage). You can run the command-line utility from a command prompt by typing rsm.

The syntax of the command-line utility is:

rsm allocate | createpool | deallocate | deletepool | dismount | eject | ejectatapi | mount | refresh | view

Each command has its own optional parameters, called argument switches, that you can specify, keeping the following points in mind:

  • The Removable Storage service (ntmssvc) must be running for the command to succeed (except for the ejectatapi command).
  • All commands are case insensitive, except when you specify media objects by their friendly names (as opposed to their GUIDs) for an argument switch.
  • You can use only one command at one time. For example, rsm dismount is a valid command, but rsm allocate dismount is not.
  • You can only specify media using one method. For example, you can specify a piece of logical media by the friendly name or by the GUID, but not both.
  • Argument switches may be specified in any order.
  • Spaces are allowed in friendly names following an argument switch, in which case the name must be enclosed by quotes. For example, you could specify the name of a media pool that has spaces in it as /m"My Media Pool" in the allocate command. However, no spaces are allowed between a tag and the actual argument switch. For example, for the timeout argument in the allocate command, the timeout is specified as /t50 and not /t 50.
  • Optional argument switches are enclosed in square braces ([ ]).

Notes

  • Certain argument switches require you to type in a media ID, which is the globally unique identifier (GUID) for the object. For information on the various GUIDs used by Removable Storage, see the Windows 2000 Resource Kit.
  • Argument switches followed by [g | f] denote GUID and friendly name respectively. For example, the proper syntax for specifying a logical media ID would be /lg logical_media_id, while the proper syntax for specifying a logical media name would be /lf logical_media_name.
  • For all commands, the GUIDs may be obtained by using the View command with either the /guid_display switch or the /b switch.

Allocate command

Media are allocated from the media pool that is specified by the /m switch. When using the allocate command, logical media can be specified by a name and a description using the /ln and /ld switches respectively. Similarly, media sides (or partitions) can be specified by a name and description using the /pn and /pd switches respectively.

Logical media names and side names can be used in other commands to specify media as the parameter to the /lf or /pf switch respectively. If logical media names (which are friendly names) are not used with the allocate command, you can only use GUIDs (and not friendly names) in subsequent commands to specify logical media.

The syntax of the allocate command is as follows:

rsm allocate /mmedia_pool_name

/o[errunavail|new|next]

[/l[g|f]logical_media_id | /p[g|f]partition_id]

[/lnlogical_media_name]

[/ldlogical_media_description]

[/pnpartition_name]

[/pdpartition_description]

[/ttimeout]

[/b]

where:

media_pool_name specifies the media pool from which to allocate media. This means that you will have allocated media in that pool.

logical_media_id specifies the next side of multi-sided media to allocate. This parameter is optional and must be used with the /o switch and the next parameter. After deallocating this media, the logical-media ID is invalid.

partition_id specifies the media side to allocate. This parameter is optional and remains persistent even after the media is deallocated.

timeout specifies the command time-out, in milliseconds. This parameter is optional, with the default timeout value being infinite.

One of the following optional parameters may also be used with the /o switch:

Errunavail prevents the submission of an operator request for new media if none can be allocated with the specificed constraints.

New allocates a media side that cannot be shared with another application. This can be used to reserve the second side of two-sided media. The second side can then be allocated using the next parameter.

Next allocates the next side of media that was previously allocated using the new parameter.

If the optional /b switch is used, only the GUID for the allocate operation is displayed. This aids in scripting where you want to pass the output of one command to the next with minimal parsing.

Createpool command

Creates a media pool. The name of the media pool is specified using the /m switch.

The syntax of the createpool command is as follows:

rsm createpool /mmedia_pool_name

/a[existing|always|new]

[/t[g|f]media_pool_type_id]

[/d]

[/r]

where:

media_pool_name specifies the name of the media pool to be created.

media_pool_type_id specifies the type of media that the media pool will contain. Either the friendly name or the GUID can be specified. This parameter is optional, with the default type being a media pool that contains other media pools.

One of the following optional parameters may also be used with the /a switch:

Existing opens the existing media pool or returns an error if the media pool specified does not exist.

Always opens the existing media pool or creates a new media pool if not found.

New creates a new media pool or returns an error if the media pool specified already exists.

If the optional /d switch is used, the media pool can automatically draw media from the free media pool. The default is not to draw media from the free media pool.

If the optional /r switch is used, the media pool can automatically return media to the free media pool. The default is not to return media to the free media pool.

Deallocate command

The logical media name or the media side (partition) name can be used to specify the logical media to deallocate only if one of these names were specified with the allocate command using the /ln or /pn switch respectively. Otherwise, either the logical media ID (LMID) or the partition ID (PARTID) must be specified instead.

The syntax of the deallocate command is as follows:

rsm deallocate /l[g|f]logical_media_id | /p[g|f]partition_id

where:

logical_media_id specifies the logical media to deallocate. Either the friendly name or the GUID can be specified.

partition_id specifies the media side to deallocate. Either the friendly name or the GUID can be specified.

Deletepool command

The deletepool command deletes a media pool. The name of the media pool is specified using the /m switch.

The syntax of the deletepool command is as follows:

rsm deletepool /mmedia_pool_name

where:

media_pool_name specifies the name of the media pool to be deleted.

Dismount command

The logical media name or the media side (partition) name can be used to specify the logical media to dismount only if one of these names were specified with the allocate command using the /ln or /pn switch respectively. Otherwise, either the logical media ID (LMID) or the partition ID (PARTID) must be specified instead.

The syntax of the dismount command is as follows:

rsm dismount /l[g|f]logical_media_id | /p[g|f]partition_id

[/o[deferred]]

where:

logical_media_id specifies the logical media to dismount. Either the friendly name or the GUID can be specified.

partition_id specifies the media side to dismount. Either the friendly name or the GUID can be specified.

If the optional /o switch with the optional deferred parameter is used, the media is marked as dismountable, but the media is kept in the drive. Subsequent mount commands can be completed normally. If not used, the media is dismounted from the drive immediately.

Eject command

The media to be ejected can be specified by either the physical-media ID (PMID) or the physical media name.

The syntax of the eject command is as follows:

rsm eject /p[g|f]physical_media_id

[/oeject_operation_id]

[/a[start|stop|queue]]

[/b]

where:

physical_media_id specifies the physical media to eject. Either the friendly name or the GUID can be specified.

eject_operation_id specifies the GUID for the particular eject operation. The optional /o switch can be used in conjunction with the /a switch and the stop parameter to terminate a particular eject operation. This can also be used in conjunction with the /a switch and the start parameter to display the GUID of the particular eject operation.

The /a switch is optional, with the default parameter being start. One of the following optional parameters may also be used with the /a switch:

Start starts the eject operation immediately. The media is ejected until a timeout occurs, or unless another eject command is issued with the /a switch and the stop parameter. Such eject commands must also specify the eject operation GUID using the /o switch. The timeout parameter is specified in the library object (for all eject operations) for the library. To set this timeout parameter, you must use the Removable Storage API. Can also be used in conjunction with the /o switch to display the GUID of a particular eject operation.

Stop terminates the eject operation prior to a timeout expiring. The particular eject operation can be determined using the GUID displayed when the start parameter is used with the /a switch and the /o switch.

Queue queues the media for later ejection. This can be used for libraries with multi-slot inject/eject (IE) ports.

The optional /b switch displays only the eject operation GUID for scripting purposes.

Ejectatapi command

Ejects media from an ATAPI changer by specifying the changer number. You should manually stop the Ntmssvc service before issuing this command.

The syntax of the ejectatapi command is as follows:

rsm ejectatapi /natapi_changer_number

where:

atapi_changer_number is the numeral found at the end of the string for the device name of the changer. For example, \\.\CdChanger0 has 0 as the ATAPI changer number.

Mount command

The logical media to be mounted can be specified using either the logical-media ID (LMID) or the logical media name.

If you do not specify a drive ID for a multidrive library, Removable Storage selects an available drive in the library.

The syntax of the mount command is as follows:

rsm mount /l[g|f]logical_media_id | /p[g|f]partition_id |
[/s[g|f]slot_id  /c[g|f]changer_id]

[/d[g|f]drive_id]

/o[errunavail|drive|read|write|offline]

[/r[normal|high|low|highest|lowest]]

[/ttimeout]

logical_media_id specifies the logical media to mount. Either the friendly name or the GUID can be specified.

partition_id specifies the media side to mount. Either the friendly name or the GUID can be specified.

changer_id specifies the changer that contains the media to be mounted. Either the friendly name or the GUID can be specified. This can only be used in conjunction with the /sg switch and the slot GUID.

slot_id specifies the media slot that contains the media to be mounted. Either the friendly name or the GUID can be specified. This can only be used in conjunction with the /cg switch and the changer GUID.

drive_id specifies the particular drive on which to mount the applicable media. Either the friendly name or the GUID can be specified. This parameter is optional, and must be used in conjunction with the /o switch and the drive parameter.

One of the following optional parameters may also be used with the /o switch:

Errunavail generates an error if either the media or the drive is unavailable.

Drive specifies that a particular drive is to be mounted. This parameter is used in conjunction with the /d switch.

Read mounts the media for read access.

Write mounts the media for write access. If this parameter is used, completed media will not be mounted.

Offline generates an error if the media is offline.

The optional /r switch specifies the mount order, or priority. Mount priority may also be specified using one of the listed parameters. These parameters are optional with the default priority being normal.

timeout specifies the command time-out, in milliseconds. This parameter is optional with the default timeout being infinite.

Note

  • When using the mount command, you can specify the media to be mounted using either the /l switch, the /p switch, or a combination of the /s switch and the /c switch.

Refresh command

The refresh command is used to refresh a library, physical media, or all devices of a particular media type. This command causes a single poll of the target devices so that the Removable Storage database contains the current state of the device. This command can be useful after media inject or eject operations.

rsm refresh /l[g|f]library_id | /p[g|f]physical_media_id | /tgmedia_type_id

library_id specifies the library to be refreshed. Either the friendly name or the GUID can be specified.

physical_media_id specifies the physical media to be refreshed. Either the friendly name or the GUID can be specified.

media_type_id specifies the media type to be refreshed. Only the GUID can be specified. This parameter can be used to refresh all removable media devices by specifying the GUID for the "removable media" media type. This GUID can be determined using the view command as follows: rsm view /tmedia_type /guid_display.

View Command

The view command displays a list of media objects. When used without any parameter for the /t switch, this command displays a list of all media pools in the Removable Storage system (collection of libraries).

The syntax of the view command is as follows:

rsm view /t[drive|library|changer|storageslot|iedoor|ieport|physical_media|
media_pool|partition|logical_media|media_type|drive_type|librequest]

[/cgcontainer_id]

[/guid_display]

[/b]

where:

container_id specifies the GUID for the object container. The type of container depends on the object type (parameter) specified with the /t switch. If the container ID is not specified, all instances of the applicable object type are displayed.

The optional /guid_display switch displays both the GUID and the friendly name for objects.

The optional /b switch displays only the object GUID for scripting purposes.

Note

  • If the /guid_display switch and the /b switch are not used, only the friendly names for objects are displayed.

Error codes

If a command succeeds, then the code ERROR_SUCCESS is returned. All commands that fail return an error code, which can be used for scripting purposes. The error code is either a system-defined error code or one of the following:

536870913: Invalid arguments were specified. Frequently, this is caused by a space after an argument switch, for example, /t 50 instead of /t50.

536870914: Duplicate argument switches were specified. For example, the allocate command used with two /m switches.

536870915: No GUID matches the friendly name that was specified. Check capitalization, as friendly names are case-sensitive.

536870916: An insufficient number of argument switches were specified. Check to see if a required switch is missing.

536870917: An invalid GUID was specified. Use the view command to determine the correct GUID for an object.

536870918: This is returned only by the ejectatapi command. Verify that the ATAPI changer is functioning correctly.


Resources

This section provides sources of additional information for Removable Storage.

Windows 2000 Resource Kit

The Microsoft Windows 2000 Resource Kit contains advanced information on how to configure, administer, optimize, and troubleshoot Removable Storage. The full version of the Windows 2000 Resource Kit is a complementary product to Windows 2000. However, the Windows 2000 compact disc set contains a subset of the full Windows 2000 Resource Kit. For more information, see the Windows 2000 Resource Kit.

Web site

Removable Storage is provided by HighGround Systems, Inc., a Microsoft partner. For more information about Removable Storage and other storage resource solutions from HighGround Systems for Windows, refer to the HighGround Systems Web site. (http://www.highground.com)


Troubleshooting

This section provides problem-solving guidelines for Removable Storage and for libraries. Problems may occur when Removable Storage attempts to automatically configure robotic libraries.

What problem are you having?

Windows 2000 cannot detect the library after you install it.

Cause: The library may not be supported by Windows 2000.

Solution: Verify that the library is listed in the Microsoft Windows Hardware Compatibility List. For a comprehensive list of the libraries supported by Windows operating systems, see the Microsoft Windows Hardware Compatibility List at the Microsoft Web site. (http://www.microsoft.com/) Make sure you have configured the library according to any guidelines listed for the applicable library.

Cause: The library may not be properly connected to your computer.

Solution: Verify that the library is properly connected to your computer. If a robotic library is connected to a SCSI host adapter (by means of a a SCSI cable), make sure there are no SCSI ID conflicts with other devices in your computer, such as your hard drive or CD-ROM drive. In addition, verify that all cables are installed and terminated properly in accordance with the guidelines for SCSI operation, especially that the maximum length for such cables is not exceeded.

Removable Storage has stopped the automatic configuration process for a robotic library.

Cause: Occasionally, Windows 2000 will configure a drive inside a robotic library before the library itself has been configured. In this situation, Removable Storage will complete the configuration process once Windows 2000 is done configuring the library.

Solution: Verify that Windows 2000 has recognized the library and associated drives and has configured the device drivers correctly.

Removable Storage was unable to automatically configure a robotic library.

Cause: The library may not support drive-element address reporting. Consequently, Removable Storage cannot map each drive in the library to a particular drive bay.

Solution: Use only libraries that support drive-element address reporting, and connect all library drives on the same SCSI bus as the associated drive bay. For information on whether your library supports drive-element address reporting, consult the library manufacturer.

Solution: If Removable Storage still cannot automatically configure your library correctly, you will need to manually configure it. However, do not use this method unless it is absolutely necessary because manually configured libraries do not recognize system configuration changes and also involve registry changes. For information on how to configure your libraries manually, see the Windows 2000 Resource Kit.

The library is configured correctly but is malfunctioning.

Cause: Many such problems can be caused by hardware device errors.

Solution: See the Windows 2000 system event log for details. You can use Event Viewer to view the error messages stored in the event log. Look for specific Removable Storage error messages as well as for device, drive, and controller error messages to pinpoint the source of the problem. Contact the library manufacturer once you have ruled out Removable Storage as the source of the problem.

When configuring a media pool, Removable Storage cannot detect the media type.

Cause: The library may not contain any tapes or discs.

Solution: Before you create a new media pool, insert media into each robotic library you want Removable Storage to control.

You cannot set or change security for Removable Storage.

Cause: Removable Storage requires that you have administrative permissions for these operations.

Solution: Verify that you are logged on with administrative permissions.